var KEYBOARD = {ready: false, init: function(container, container) {
	KEYBOARD = (function() {
	var container = this.container;
	var document = this.document;
	var visible = true;
	var isShift = false;
	var isMain = true;
	function init(main_req, layout_req, canShift) {
		xmlhttp.open("GET", main_req, false);
		xmlhttp.send();
		var maxCols = parseInt(xmlhttp.responseText);
		var size = DIMENSIONS.getDimensions().width / (maxCols +2);
		size = Math.floor(size- 10);
		xmlhttp.open("GET", layout_req, false);
		xmlhttp.send();
		var rows = parseInt(xmlhttp.responseText);
		var HTML = "";
		for (var y = 0; y < rows; y++) {
			xmlhttp.open("GET", layout_req + "?y=" + y,false);
			xmlhttp.send();
			var cols = parseInt(xmlhttp.responseText);
			HTML += '<div class="row">';
			if (canShift && y == rows -2) {
				HTML+='<div class="key" style="width: '+(size*2)+'px; height: '+size+'px;" onmouseup="KEYBOARD.shift()">shift</div>';
			}
			if (y == rows -1) {
				HTML+='<div class="key" style="width: '+(size)+'px; height: '+size+'px;" onmouseup="KEYBOARD.switch_keyboard()">sym</div>';
			}
			for (var x = 0; x < cols; x++) {
				xmlhttp.open("GET", layout_req + "?y=" + y + "&x=" + x,false);
				xmlhttp.send();
				var ch = xmlhttp.responseText;
				if (ch.length > 1) {
					HTML+='<div class="key keychar" style="width: '+size+'px; height: '+size+'px;" onmouseup="KEYBOARD.clickNum(\''+ch.substring(1)+'\')">' + ch.charAt(0) + '</div>';
				} else {
					HTML+='<div class="key keychar" style="width: '+size+'px; height: '+size+'px;" onmouseup="KEYBOARD.click(\''+ch+'\')">' + ch + '</div>';
				}
				if (y == rows-1 && x == 3)
					HTML += '<div class="key" style="width: '+(size*4)+'px; height: '+size+'px;" onmouseup="KEYBOARD.space()">&nbsp;</div>';
			}
			if ((y == rows -3 && canShift) || (y == rows -2 && !canShift)) {
				HTML+='<div class="key" style="width: '+(size*2)+'px; height: '+size+'px;" onmouseup="KEYBOARD.enter()">enter</div>';
			}
			if (y == 0) {
				HTML+='<div class="key" style="width: '+(size*2)+'px; height: '+size+'px;" onmouseup="KEYBOARD.backspace()"><-</div>';
			}
			HTML += "</div>";
		}
		return HTML;
	}
	var htmlMain = init(REQUESTS.KB_MAXCOLS_MAIN, REQUESTS.KB_LAYOUT_MAIN, true);
	var htmlAdv = init(REQUESTS.KB_MAXCOLS_ADV, REQUESTS.KB_LAYOUT_ADV, false);
	console.log(container);
	container.innerHTML = '<div id="mainKeyboard">'+htmlMain + '</div><div id="advKeyboard">' + htmlAdv +'</div>';
	showHide();

	function showHide() {
		if (visible) {
			container.style.display = 'none';
		} else {
			container.style.display = 'block';
		}
		visible=!visible;
	}
	function shift() {
		isShift = !isShift;
		if (isShift) {
			container.className = "shifted";
		} else {
			container.className = "";
		}
	}
	function click(key) {
		try {
			xmlhttp.open("GET", REQUESTS.KB_CLICK + "?key=" + (isShift ? key.toUpperCase() : key),true);
			xmlhttp.send();
		} catch (e) {
			console.log(e);
		}
	}
	function clickNum(key) {
		try {
			xmlhttp.open("GET", REQUESTS.KB_CLICK + "?code=" + key,true);
			xmlhttp.send();
		} catch (e) {
			console.log(e);
		}
	}
	function switch_keyboard() {
		isMain = !isMain;
		if (!isMain) {
			document.getElementById('mainKeyboard').style.display = 'none';
			document.getElementById('advKeyboard').style.display = 'block';
		} else {
			document.getElementById('mainKeyboard').style.display = 'block';
			document.getElementById('advKeyboard').style.display = 'none';
		}
	}
	return {
		showHide: showHide,
		shift: shift,
		backspace: function() {
			xmlhttp.open("GET", REQUESTS.KB_CLICK_BACKSPACE,true);
			xmlhttp.send();
		},
		enter: function() {
			xmlhttp.open("GET", REQUESTS.KB_CLICK_RETURN,true);
			xmlhttp.send();
		},
		space: function() {
			xmlhttp.open("GET", REQUESTS.KB_CLICK_SPACE,true);
			xmlhttp.send();
		},
		click: click,
		clickNum: clickNum,
		switch_keyboard: switch_keyboard
	}
}).call({container: container, document: document})}};